module.exports = function (grunt) {
    'use strict';

    grunt.loadNpmTasks('grunt-contrib-copy');

    grunt.initConfig({
        copy: {
            main: {
                files: [
                    // jQuery
                    { expand: true, flatten: true, src: ['node_modules/jquery/dist/jquery.min.js'], dest: 'static/static/js/' },

                    // Bootstrap
                    { expand: true, flatten: true, src: ['node_modules/bootstrap/dist/css/bootstrap.min.css'], dest: 'static/static/css/' },
                    { expand: true, flatten: true, src: ['node_modules/bootstrap/dist/css/bootstrap-theme.min.css'], dest: 'static/static/css/' },
                    { expand: true, flatten: true, src: ['node_modules/bootstrap/dist/js/bootstrap.min.js'], dest: 'static/static/js/' },

                    // lightgallery
                    { expand: true, flatten: true, src: ['node_modules/lightgallery/dist/css/lightgallery.min.css'], dest: 'static/static/css/' },
                    { expand: true, flatten: true, src: ['node_modules/lightgallery/dist/js/lightgallery.min.js'], dest: 'static/static/js/' },
                    { expand: true, flatten: true, src: ['node_modules/lightgallery/dist/fonts/*'], dest: 'static/static/fonts/' },

                    // lightslider
                    { expand: true, flatten: true, src: ['node_modules/lightslider/dist/css/lightslider.min.css'], dest: 'static/static/css/' },
                    { expand: true, flatten: true, src: ['node_modules/lightslider/dist/js/lightslider.min.js'], dest: 'static/static/js/' },
                    { expand: true, flatten: true, src: ['node_modules/lightslider/dist/img/*'], dest: 'static/static/img/' },

                    // Fontawesome 4.x
                    { expand: true, flatten: true, src: ['node_modules/font-awesome/css/font-awesome.min.css'], dest: 'static/static/css/' },
                    { expand: true, flatten: true, src: ['node_modules/font-awesome/fonts/*'], dest: 'static/static/fonts/' },

                    // fortawesome
                    // { expand: true, flatten: true, src: ['node_modules/@fortawesome/fontawesome-free/css/all.min.css'], dest: 'static/static/css/' },
                    // { expand: true, flatten: true, src: ['node_modules/@fortawesome/fontawesome-free/webfonts/*'], dest: 'static/static/webfonts/' },
                ],
            },
        },
    });

    grunt.registerTask('default', ['copy:main']);
};